<?php

namespace Service\ChartView;

class ChartTypeError implements ChartViewInterface {
    public $widget;
    public $errorMessage;

    function __construct($widget = null, $error = null) {
        $this->widget = $widget;
        $this->errorMessage = "Ocorreu um erro ao renderizar o indicador.";
        if ($error == "NO_DATA") {
            $this->errorMessage = !empty($this->widget["chartMessageNoData"]) ? $this->widget["chartMessageNoData"] : "Não há dados para o período selecionado!";
        }
    }

	public function convertToNext():array {
		return [
            "name" => "notFound",
            "component" => "zdContainer",
            "cssClass" => "fill-height zd-pa-0 zd-ma-0",
            "justify" => "center",
            "align" => "center",
            "cssStyle" => "width: 100%; height: 100%; overflow: hidden !important; overflow-x: hidden !important; overflow-y: hidden !important;",
            "children" => [
                [
                    "name" => "notFound_title",
                    "component" => "ZdText",
                    "text" => $this->widget["label"],
                    "cssStyle" => "color: black !important;",
                    "tag" => "h3",
                ],
                [
                    "name" => "notFound_row",
                    "component" => "ZdRow",
                    "cssClass" => "fill-height",
                    "justify" => "center",
                    "align" => "center",
                    "cssStyle" => "width: 100%; height: 100%",
                    "children" => [
                        [
                            "name" => "text_noData",
                            "component" => "ZdText",
                            "text" => $this->errorMessage,
                            "tag" => "h3"
                        ],
                    ]
                ]
            ]
        ];
	}
}