<?php


namespace Util;


class PaginationPhp
{

    protected $orderFields = array();

    public function paginationAndOrderINPhpNext($style, $params)
    {
        if (array_key_exists("order", $params)) {
            $periodData = $style['data'];
            $order = $params['order'];

            foreach ($order as &$orderField) {
                $orderField = explode(".", $orderField);
            }

            $this->orderFields = $order;
            usort($periodData, array($this, 'comparator'));
            $style['data'] = $periodData;
        }

        $limit = -1;
        if (array_key_exists("limit", $params)) {
            $limit = intval($params['limit']);
            $style['pagination']['limit'] = $limit;
            $styleData = array_chunk($style['data'], $limit);
        }

        $page = 1;
        if (array_key_exists("page", $params)) {
            $page = intval($params['page']);
            $style['pagination']['page'] = $page;
            if ($limit != -1 && sizeof($styleData) >= $page) $style['data'] = $styleData[$page - 1];
        }

        return $style;
    }

    private function comparator($object1, $object2)
    {
        $orderList = $this->orderFields;
        foreach ($orderList as $order) {
            $orderResult = ($order[1] == 'asc') ? $this->comparatorAsc($object1, $object2, $order[0]) : $this->comparatorDesc($object1, $object2, $order[0]);
            if ($orderResult)
                return $orderResult;
        }
        return 0;
    }

    private function comparatorAsc($object1, $object2, $field)
    {
        if(empty($object1[$field])){
            return -1;
        }else if(empty($object2[$field])){
            return 1;
        }
        return strcmp($object1[$field], $object2[$field]);
    }

    private function comparatorDesc($object1, $object2, $field)
    {
        if(empty($object1[$field])){
            return 1;
        }else if(empty($object2[$field])){
            return -1;
        }
        return strcmp($object2[$field], $object1[$field]);
    }
}
